import type { Atom, Getter, WritableAtom } from 'jotai';
declare type AnyError = unknown;
declare global {
    interface SymbolConstructor {
        readonly observable: symbol;
    }
}
declare type Subscription = {
    unsubscribe: () => void;
};
declare type Observer<T> = {
    next: (value: T) => void;
    error: (error: AnyError) => void;
    complete: () => void;
};
declare type ObservableLike<T> = {
    subscribe(observer: Observer<T>): Subscription;
    subscribe(next: (value: T) => void, error?: (error: AnyError) => void, complete?: () => void): Subscription;
    [Symbol.observable]?: () => ObservableLike<T> | undefined;
};
declare type SubjectLike<T> = ObservableLike<T> & Observer<T>;
declare type Options<Data> = {
    initialValue?: Data | (() => Data);
    unstable_timeout?: number;
};
export declare function atomWithObservable<Data>(createObservable: (get: Getter) => SubjectLike<Data>, options?: Options<Data>): WritableAtom<Data, Data>;
export declare function atomWithObservable<Data>(createObservable: (get: Getter) => ObservableLike<Data>, options?: Options<Data>): Atom<Data>;
export {};
